/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

package com.trolltech.qt;

/**
 * The QtEnumerator interface servers as a base for all Qt Jambi enums
 * and flags. Its sole purpose is to unify the access to the integer
 * value of enumerators and flags using the value() method.
 *
 * If you manually implement this class, your implementation must contain a method
 * with the following signature:
 *
 *      public static T resolve(int value);
 *
 * where T is your subclass. This should return the enum value corresponding to the
 * specified int value.
 */
public interface QtEnumerator {
    /**
     * This function should return an integer value for the enum
     * values of the enumeration that implements this interface.
     */
    public int value();
}
